{$A+,B-,F-,G+,K+,N-,Q-,R-,S-,W-,X+} {$M 1024,0}
Library KBD_CT; {$d                 c't-Tastaturtabelle }
                {$ifndef Windows}   fr Microsoft Windows
                {$endif}{           Martin Krieger - c't 12/93  }
uses winprocs, wintypes;
{$r kbd_ct.res}
const  { Resourcenkonstanten }
  rt_Tastaturtab= $0abc;     rd_KbdTable= 1;
  rd_KeyTrTab= 2;            rd_Header= 3;
  rd_KeyNames= 4;

type
  PHeader= ^THeader;
  THeader= array [0..47] of byte;
  PKeyTrTab= PChar;    { Kein String, aber nullterminiert }
  PNamenTab= ^TNamenTab;
  TNamenTab= record
               positionen: array [0..76] of word;
               namen: array [0..8888] of char;
                {Lnge unbekannt. 8888 steht fr "Offenes Ende" }
             end;

Function GetKbdTable(KbdType: word; KeyTrTab: PKeyTrTab;
           Header: PHeader): pointer; export;
var
  ResData: THandle;
  HeaderDaten: PHeader;
  KeyTrTabDaten: PKeyTrTab;
  w: Word;
begin { Hole die Informationen ber die Tabellen aus der Resource }
  ResData:= LoadResource(HInstance, FindResource(HInstance,
    makeintresource(rd_Header), makeintresource(rt_Tastaturtab)));
  HeaderDaten:= LockResource(ResData);
  Header^:=HeaderDaten^; { und kopiere sie.}
  UnlockResource(ResData);
  FreeResource(ResData);
    { Die Tabelle Scancode -> VK_ holen }
  ResData:= LoadResource(HInstance, FindResource(HInstance,
    makeintresource(rd_KeyTrTab),makeintresource(rt_Tastaturtab)));
  KeyTrTabDaten:= LockResource(ResData);
  w:= 0;     { und bis zur Lnge der krzeren Tabelle kopieren. }
  while (KeyTrTabDaten[w] <> #0) and (KeyTrTab[w] <> #0) do begin
    KeyTrTab[w] := KeyTrTabDaten[w];
    inc (w)
  end;
  UnlockResource(ResData);
  FreeResource(ResData);
    { Finale: Die eigentliche Tastaturtabelle }
  ResData:= LoadResource(HInstance, FindResource(HInstance,
    makeintresource(rd_KbdTable), makeintresource(rt_Tastaturtab)));
  GetKbdTable:=LockResource(ResData);
end;

Function GetKeyString(nString: integer; StringOut: PChar;
           Size: word):integer; export;
  { Gibt die "Namen" von Tasten zurck. Fehlen die Funktion und die }
  { dazugehrige Resource, wird die US-Tabelle benutzt. }
var
  ResData: THandle;
  NamenTab: PNamenTab;
  w: Word;
begin
  ResData:= LoadResource(HInstance, FindResource(HInstance,
    makeintresource(rd_KeyNames), makeintresource(rt_Tastaturtab)));
  NamenTab:= LockResource(ResData);
  w:=0;
  with NamenTab^ do begin
    if Size> 0 then begin
      repeat
        StringOut[w]:= namen[positionen[nString]+w];
        inc(w);
      until ((w>Size) or (namen[positionen[nString]+w-1]=#0));
      dec(w)
    end;
  end;
  UnlockResource(ResData);
  FreeResource(ResData);
  GetKeyString:= w;
end;

exports
  GetKbdTable index 1,
  GetKeyString index 2;

Begin { Kein Hauptmodul }
end.